#include <GL/gl.h>
#include <stdlib.h>
#include <stdio.h>
#include "bench.h"

int Bench::counter = 0;
GLuint Bench::list = 0;

Texture *Bench::wood = NULL;

GLfloat Bench::pewterSpecular[] = {0.1059, 0.0588, 0.1137, 1.0};
GLfloat Bench::pewterDiffuse[] = {0.4275, 0.4706, 0.5412, 1.0};
GLfloat Bench::pewterAmbient[] = {0.3333, 0.3333, 0.5216, 1.0};
GLfloat Bench::pewterShininess[] = {9.85};

Bench::Bench(int x, int y, int rot) : Object(x, y, rot) {
   counter++;
   if(counter == 1) {
      wood = new Texture("data/wood.tga");
      list = glGenLists(3);
      if(list != 0) {
         this->lista();
         this->kul();
         this->lavicka();
      }
      else {
         printf("Cannot create lists.");
         getchar();
         exit(1);
      }
   }
}

Bench::~Bench() {
   counter--;
   if(counter == 0) {
      delete wood;
      glDeleteLists(list, 3);
   }
}

void Bench::lista() {
   glNewList(list + 1, GL_COMPILE);
     glBegin(GL_QUADS);
       glNormal3f(0.0, 1.0, 0.0);
       glTexCoord2f(0.0, 0.0); glVertex3f(0.0, 0.0, 0.0);
       glTexCoord2f(0.4, 0.0); glVertex3f(0.0, 0.0, -0.2);
       glTexCoord2f(0.4, 2.0); glVertex3f(1.0, 0.0, -0.2);
       glTexCoord2f(0.0, 2.0); glVertex3f(1.0, 0.0, 0.0);

       glNormal3f(0.0, 0.0, 1.0);
       glTexCoord2f(0.4, 0.0); glVertex3f(0.0, 0.0, -0.2);
       glTexCoord2f(0.4, 2.0); glVertex3f(1.0, 0.0, -0.2);
       glTexCoord2f(0.5, 2.0); glVertex3f(1.0, 0.05, -0.2);
       glTexCoord2f(0.5, 0.0); glVertex3f(0.0, 0.05, -0.2);

       glNormal3f(0.0, -1.0, 0.0);
       glTexCoord2f(0.5, 0.0); glVertex3f(0.0, 0.05, 0.0);
       glTexCoord2f(0.9, 0.0); glVertex3f(0.0, 0.05, -0.2);
       glTexCoord2f(0.9, 2.0); glVertex3f(1.0, 0.05, -0.2);
       glTexCoord2f(0.5, 2.0); glVertex3f(1.0, 0.05, 0.0);

       glNormal3f(0.0, 0.0, -1.0);
       glTexCoord2f(0.9, 0.0); glVertex3f(0.0, 0.0, 0.0);
       glTexCoord2f(0.9, 2.0); glVertex3f(1.0, 0.0, 0.0);
       glTexCoord2f(1.0, 2.0); glVertex3f(1.0, 0.05, 0.0);
       glTexCoord2f(1.0, 0.0); glVertex3f(0.0, 0.05, 0.0);

       glNormal3f(1.0, 0.0, 0.0);
       glTexCoord2f(0.0, 0.0); glVertex3f(0.0, 0.0, 0.0);
       glTexCoord2f(0.0, 0.1); glVertex3f(0.0, 0.0, -0.2);
       glTexCoord2f(0.1, 0.1); glVertex3f(0.0, 0.05, -0.2);
       glTexCoord2f(0.1, 0.0); glVertex3f(0.0, 0.05, 0.0);

       glNormal3f(-1.0, 0.0, 0.0);
       glTexCoord2f(0.0, 0.0); glVertex3f(1.0, 0.0, 0.0);
       glTexCoord2f(0.0, 0.1); glVertex3f(1.0, 0.0, -0.2);
       glTexCoord2f(0.1, 0.1); glVertex3f(1.0, 0.05, -0.2);
       glTexCoord2f(0.1, 0.0); glVertex3f(1.0, 0.05, 0.0);
     glEnd();
   glEndList();
}

void Bench::kul() {
   glNewList(list + 2, GL_COMPILE);
     glBegin(GL_QUADS);
       glColor3f(0.6,0.6,0.6);
       glNormal3f(1.0, 0.0, 0.0);
       glVertex3f(0.0, 0.0, 0.0); glVertex3f(0.0, 1.0, 0.0); glVertex3f(0.0, 1.0, 0.06); glVertex3f(0.0, 0.0, 0.06);
          
       glNormal3f(0.0, 0.0, 1.0);
       glVertex3f(0.0, 0.0, 0.0); glVertex3f(0.06, 0.0, 0.0); glVertex3f(0.06, 1.0, 0.0); glVertex3f(0.0, 1.0, 0.0);
          
       glNormal3f(-1.0, 0.0, 0.0);
       glVertex3f(0.06, 0.0, 0.0); glVertex3f(0.06, 1.0, 0.0); glVertex3f(0.06, 1.0, 0.06); glVertex3f(0.06, 0.0, 0.06);
          
       glNormal3f(0.0, 0.0, -1.0);
       glVertex3f(0.0, 0.0, 0.06); glVertex3f(0.06, 0.0, 0.06); glVertex3f(0.06, 1.0, 0.06); glVertex3f(0.0, 1.0, 0.06);
       glColor3f(1.0,1.0,1.0);
     glEnd();
   glEndList();
}

void Bench::lavicka() {
   glNewList(list, GL_COMPILE);
     glPushMatrix();
     glEnable(GL_NORMALIZE);
        
     glBindTexture(GL_TEXTURE_2D, 0);
     glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, pewterSpecular);
     glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, pewterDiffuse);
     glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, pewterAmbient);
     glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, pewterShininess);
        
     glScaled(2,2,2);

     glPushMatrix();
     glScaled(1,1.1,1);
     glTranslated(0.1,0,0.05);
     glCallList(list + 2);
     glTranslated(0.7,0,0);
     glCallList(list + 2);
     glPopMatrix();

     glPushMatrix();
     glScaled(1,0.5,1);
     glTranslated(0.1,0,-0.4);
     glCallList(list + 2);
     glTranslated(0.7,0,0);
     glCallList(list + 2);
     glPopMatrix();
        
     glPushMatrix();
     glScaled(1,1,0.45);
     glTranslated(0.1, 0.5, -0.8);
     glRotated(90,1,0,0);
     glCallList(list + 2);
     glTranslated(0.7,0,0);
     glCallList(list + 2);
     glPopMatrix();
        
     glBindTexture(GL_TEXTURE_2D, wood->getTexID());
     glPushMatrix();
     glTranslated(0,0.5,0);
     glCallList(list + 1);
     glTranslated(0,0,-0.25);
     glCallList(list + 1);
     glPopMatrix();

     glTranslated(0,0.6,0);
     glRotated(90,1,0,0);
     glCallList(list + 1);
     glTranslated(0,0,-0.25);
     glCallList(list + 1);
        
     glDisable(GL_NORMALIZE);
     glPopMatrix();
   glEndList();
}

void Bench::bounds() {
   glBegin(GL_LINE_STRIP);
     glVertex3f(-0.1, 0, 0.3);
     glVertex3f(-0.1, 2.5, 0.3);
     glVertex3f(2.1, 2.5, 0.3);
     glVertex3f(2.1, 0, 0.3);
   glEnd();
   glBegin(GL_LINE_STRIP);
     glVertex3f(-0.1, 0, -1);
     glVertex3f(-0.1, 2.5, -1);
     glVertex3f(2.1, 2.5, -1);
     glVertex3f(2.1, 0, -1);
   glEnd();
   glBegin(GL_LINES);
     glVertex3f(-0.1, 2.5, 0.3);
     glVertex3f(-0.1, 2.5, -1);
     glVertex3f(2.1, 2.5, 0.3);
     glVertex3f(2.1, 2.5, -1);
   glEnd();
}

void Bench::innerDraw() {
   glCallList(list);
}

char *Bench::save() {
   char name[255];
   sprintf(name, "\nL %d %d %d", x, y, rot);
   return name;
}

char *Bench::getName() {
   char *name;
   name = new char[255];
   sprintf(name, "Bench %d", index);
   return name;
}

