#ifndef CAMERA_H
#define CAMERA_H

#include <GL/gl.h>

class Camera {
   private:
      enum View {ORTO, PER, STATIC};

      GLdouble posx, posy, posz;
      GLint ay, ax;
      View view;
    
      void normalize();
    
   public:
      Camera();
      void setPos(GLdouble x, GLdouble y, GLdouble z);
      void setAngles(int x, int y);
      void addAngleY(GLint y);
      void addAngleX(GLint x);
      void goUp();
      void goDown();
      void addPosY(GLdouble y);
      char *changeView();
      void look(void);
      void selectLook(void);
      void project(void);
};

#endif
