#ifndef ENGINE_H
#define ENGINE_H

#include "camera.h"
#include "textviewer.h"
#include "texture.h"
#include "sphere.h"
#include "sun.h"
#include "storage.h"
#include "surface.h"

class Engine {
   private:
      enum MODE {MOVEX, MOVEY, ROT};
      MODE mode;
      bool sunmove, skymove, lighting, fog;
      Camera *cam;
      TextViewer *text;
      Sphere *sph;
      Sun *sun;
      Storage *store;
      Surface *desk;
      int lastx, width, height;

      void change();
      void drawSurface();
      int sign(int x);

	public:
		Engine();
		~Engine();
      void draw();
      void drag(int x, int y);
      void menu(int item);
      void key(unsigned char key, int x, int y);
      void speckey(int key, int x, int y);
      void mouse(int button, int state, int x, int y);
      void resize(int width, int height);
};

#endif
