#include <GL/gl.h>
#include <GL/glu.h>
#include <stdlib.h>
#include <stdio.h>
#include "leaftree.h"

int LeafTree::counter = 0;
GLuint LeafTree::list = 0;

Texture *LeafTree::noha = NULL;
Texture *LeafTree::listi = NULL;

LeafTree::LeafTree(int x, int y, int rot) : Object(x, y, rot) {
   counter++;
   if(counter == 1) {
      noha = new Texture("data/kura.tga");
      listi = new Texture("data/listnac.tga");
      list = glGenLists(1);
      if(list != 0) {
         this->listnac();
      }
      else {
         printf("Cannot create list.");
         getchar();
         exit(1);
      }
   }
}

LeafTree::~LeafTree() {
   counter--;
   if(counter == 0) {
      delete noha;
      delete listi;
      glDeleteLists(list, 1);
   }
}

void LeafTree::listnac() {
   glNewList(list, GL_COMPILE);
     glPushMatrix();
     glBindTexture(GL_TEXTURE_2D, noha->getTexID());
     glEnable(GL_NORMALIZE);
     glScaled(2,1,2);
     glBegin(GL_QUADS);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(0.0, 0.0); glVertex3f(-0.2, 0.0, -0.2);
       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 0.0); glVertex3f(0.2, 0.0, -0.2);
       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 1.0); glVertex3f(0.2, 2.0, -0.2);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(0.0, 1.0); glVertex3f(-0.2, 2.0, -0.2);

       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 0.0); glVertex3f(0.2, 0.0, -0.2);
       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 0.0); glVertex3f(0.2, 0.0, 0.2);
       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 1.0); glVertex3f(0.2, 2.0, 0.2);
       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 1.0); glVertex3f(0.2, 2.0, -0.2);

       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 0.0); glVertex3f(0.2, 0.0, 0.2);
       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 0.0); glVertex3f(-0.2, 0.0, 0.2);
       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 1.0); glVertex3f(-0.2, 2.0, 0.2);
       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 1.0); glVertex3f(0.2, 2.0, 0.2);

       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 0.0); glVertex3f(-0.2, 0.0, 0.2);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(1.0, 0.0); glVertex3f(-0.2, 0.0, -0.2);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(1.0, 1.0); glVertex3f(-0.2, 2.0, -0.2);
       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 1.0); glVertex3f(-0.2, 2.0, 0.2);
     glEnd();
     glTranslated(0,7,0);
     glScaled(0.5, 1.5, 0.5);
     GLUquadricObj *quadratic = gluNewQuadric();
     gluQuadricTexture(quadratic, GL_TRUE);
     gluQuadricOrientation(quadratic, GLU_INSIDE);
     gluQuadricNormals(quadratic, GLU_SMOOTH);
     glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
     glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
      
     glBindTexture(GL_TEXTURE_2D, listi->getTexID());
     glMatrixMode(GL_TEXTURE);
     glPushMatrix();
     glScaled(10,10,10);
     glMatrixMode(GL_MODELVIEW);
     gluSphere(quadratic, 4.0, 16, 16);
     glMatrixMode(GL_TEXTURE);
     glPopMatrix();
     glMatrixMode(GL_MODELVIEW);
     gluDeleteQuadric(quadratic);
     glDisable(GL_NORMALIZE);
     glPopMatrix();
   glEndList();
}

void LeafTree::bounds() {
   glBegin(GL_LINE_STRIP);
     glVertex3f(-4, 0, 4);
     glVertex3f(-4, 14, 4);
     glVertex3f(4, 14, 4);
     glVertex3f(4, 0, 4);
   glEnd();
   glBegin(GL_LINE_STRIP);
     glVertex3f(-4, 0, -4);
     glVertex3f(-4, 14, -4);
     glVertex3f(4, 14, -4);
     glVertex3f(4, 0, -4);
   glEnd();
   glBegin(GL_LINES);
     glVertex3f(-4, 14, +4);
     glVertex3f(-4, 14, -4);
     glVertex3f(4, 14, +4);
     glVertex3f(4, 14, -4);
   glEnd();
}

void LeafTree::innerDraw() {
   glCallList(list);
}

char *LeafTree::save() {
   char name[255];
   sprintf(name, "\nK %d %d", x, y);
   return name;
}

char *LeafTree::getName() {
   char *name;
   name = new char[255];
   sprintf(name, "Leaf Tree %d", index);
   return name;
}

