#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>
#include "engine.h"

Engine *engine;

void draw() {engine->draw();}
void drag(int x, int y) {engine->drag(x, y);}
void menu(int item) {engine->menu(item);}
void key(unsigned char key, int x, int y) {engine->key(key, x, y);}
void speckey(int key, int x, int y) {engine->speckey(key, x, y);}
void mouse(int button, int state, int x, int y) {engine->mouse(button, state, x, y);}
void resize(int width, int height) {engine->resize(width, height);}
void idle(void) {glutPostRedisplay();}

void init(void) {
   glClearColor(0,0,0,1);
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_TEXTURE_2D);
   glEnable(GL_LINE_STIPPLE);
   glDepthFunc(GL_LEQUAL);
   glShadeModel(GL_SMOOTH);
   glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}

void createMenu(void) {
   int menuId1, menuId2;

   menuId1 = glutCreateMenu(menu);
   glutAddMenuEntry("Spruce", 100);
   glutAddMenuEntry("Leaf Tree", 101);
   glutAddMenuEntry("Bench", 102);
   menuId2 = glutCreateMenu(menu);
   glutAddMenuEntry("Deselect", 204);
   glutAddMenuEntry("Move X", 201);
   glutAddMenuEntry("Move Y", 202);
   glutAddMenuEntry("Rotate", 203);
   glutAddMenuEntry("Delete", 200);

   glutCreateMenu(menu);
   glutAddSubMenu("New object", menuId1);
   glutAddSubMenu("Manipulation", menuId2);
   glutAddMenuEntry("Fullscreen", 6);
   glutAddMenuEntry("Change view", 1);
   glutAddMenuEntry("Sunmove on/off", 2);
   glutAddMenuEntry("Skymove on/off", 3);
   glutAddMenuEntry("Lighting on/off", 4);
   glutAddMenuEntry("Fog on/off", 5);
   glutAddMenuEntry("Save scene", 7);
   glutAddMenuEntry("Exit", 0);

   glutAttachMenu(GLUT_RIGHT_BUTTON);
}

void finally(void) {
   delete engine;
}

int main(int argc, char *argv[]) {
   glutInit(&argc, argv);
   glutInitWindowSize(640,480);
   glutInitWindowPosition(-1,-1);
   glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);

   glutCreateWindow("Virtual Park");

   glutReshapeFunc(resize);
   glutDisplayFunc(draw);
   glutKeyboardFunc(key);
   glutSpecialFunc(speckey);
   glutMouseFunc(mouse);
   glutMotionFunc(drag);
   glutIdleFunc(idle);

   createMenu();
   init();
   atexit(finally);
   engine = new Engine();
   
   glutMainLoop();

   return EXIT_SUCCESS;
}
