#include <stdio.h>
#include <stdlib.h>
#include "object.h"

unsigned int Object::num = 0;

Object::Object(int x, int y, int rot) {
   num++;
/*   if(num > 64) {
      printf("Too many objects... 64 is max\n");
      getchar();
      exit(1);
   }*/
   index = num;
   this->x = x;
   this->y = y;
   this->rot = rot;
   next = NULL;
}

Object::~Object() {
}

Object *Object::getLast() {
   if(next == NULL) return this;
   else return next->getLast();
}

void Object::setLast(Object *last) {
   if(next == NULL) next = last;
   else next->setLast(last);
}

void Object::draw(bool select) {
   if(select) {
      glLoadName(index);
   }
   glPushMatrix();
   glTranslated(x, 0, y);
   glRotated(rot, 0, 1, 0);
   this->innerDraw();
   glPopMatrix();
}

void Object::drawBounds(void) {
   static GLushort pat = 0x00FF;
   pat = pat << 1;
   pat = pat + (pat / 0x8000);
   glDisable(GL_LIGHTING);
   glPushMatrix();
   glTranslated(x, 0, y);
   glRotated(rot, 0, 1, 0);
   glLineStipple(1, pat);
   glBindTexture(GL_TEXTURE_2D, 0);
   glColor3f(1.0, 0.0, 0.0);
   glLineWidth(2.0);
   this->bounds();
   glPopMatrix();
   glEnable(GL_LIGHTING);
}
