#ifndef OBJECT_H
#define OBJECT_H

#include <GL/gl.h>

class Object {
   private:
      static unsigned int num;
      Object *next;
      
   protected:
      unsigned int index;
      int x, y, rot;
		virtual void innerDraw(void) = 0;
		virtual void bounds(void) = 0;
      
	public:
		Object(int x, int y, int rot);
		~Object();
		void draw(bool select);
		void drawBounds(void);
		inline void setNext(Object *next) {this->next = next;}
		inline Object *getNext() {return next;}
		Object *getLast();
		void setLast(Object *last);
		inline int getIndex() {return index;}
		inline void moveX(int dx) {x += dx;}
		inline void moveY(int dy) {y += dy;}
		inline void rotate(int angle) {rot = (rot + 360 + angle) % 360;}
		virtual char *getName() = 0;
		virtual char *save(void) = 0;
};

#endif
