#include "sphere.h"

Sphere::Sphere() {
   tex = new Texture("data/sky.tga");
   index = glGenLists(1);
   if(index != 0) {
      GLUquadricObj *quadratic = gluNewQuadric();
   	gluQuadricTexture(quadratic, GL_TRUE);
   	gluQuadricOrientation(quadratic, GLU_INSIDE);
	   gluQuadricNormals(quadratic, GLU_SMOOTH);
      glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
      glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
      
      glNewList(index, GL_COMPILE);
        glBindTexture(GL_TEXTURE_2D, tex->getTexID());
        glPushMatrix();
        glTranslated(0, -100, 0);
        glRotated(90,0,0,1);
        gluSphere(quadratic, 250.0, 32, 32);
        glPopMatrix();
      glEndList();
      gluDeleteQuadric(quadratic);
   }
}

Sphere::~Sphere() {
   delete tex;
}

void Sphere::draw(bool move) {
   static GLfloat a = 0;
   if(move) {
      a += 0.0001;
   }
   if(index != 0) {
      glMatrixMode(GL_TEXTURE);
      glPushMatrix();
      glTranslated(0, a, 0);
      glScaled(4,4,4);
      glMatrixMode(GL_MODELVIEW);
      glCallList(index);
      glMatrixMode(GL_TEXTURE);
      glPopMatrix();
      glMatrixMode(GL_MODELVIEW);
   }
}
