#include <GL/gl.h>
#include <stdlib.h>
#include <stdio.h>
#include "spruce.h"

int Spruce::counter = 0;
GLuint Spruce::list = 0;

Texture *Spruce::noha = NULL;
Texture *Spruce::jehlici = NULL;

Spruce::Spruce(int x, int y, int rot) : Object(x, y, rot) {
   counter++;
   if(counter == 1) {
      noha = new Texture("data/kura.tga");
      jehlici = new Texture("data/jehlici.tga");
      list = glGenLists(2);
      if(list != 0) {
         this->jehlan();
         this->jehlicnan();
      }
      else {
         printf("Cannot create list.");
         getchar();
         exit(1);
      }
   }
}

Spruce::~Spruce() {
   counter--;
   if(counter == 0) {
      delete noha;
      delete jehlici;
      glDeleteLists(list, 2);
   }
}

GLfloat Spruce::jehlan_vertex_up[][3] = {
   {0.0, 2.0, 0.0},
   {-1.0, 0.0, 0.0},
   {-0.707, 0.0, 0.707},
   {0.0, 0.0,1.0},
   {0.707, 0.0, 0.707},
   {1.0, 0.0, 0.0},
   {0.707, 0.0, -0.707},
   {0.0, 0.0, -1.0},
   {-0.707, 0.0, -0.707},
   {-1.0, 0.0, 0.0}
};
GLfloat Spruce::jehlan_vertex_normal[][3] = {
   {0.0, -1.0, 0.0},
   {1.0, 0.0, 0.0},
   {0.707, 0.0, -0.707},
   {0.0, 0.0, -1.0},
   {-0.707, 0.0, -0.707},
   {-1.0, 0.0, 0.0},
   {-0.707, 0.0, 0.707},
   {0.0, 0.0, 1.0},
   {0.707, 0.0, 0.707},
   {1.0, 0.0, 0.0}
};
GLfloat Spruce::jehlan_vertex_tex[][2] = {
   {1.0, 3.0},
   {0.0, 0.0},
   {0.25, 0.0},
   {0.5, 0.0},
   {0.75, 0.0},
   {1.0, 0.0},
   {1.25, 0.0},
   {1.5, 0.0},
   {1.75, 0.0},
   {2.0, 0.0}
};
GLfloat Spruce::jehlan_vertex_down[][3] = {
   {0.0, 0.0, 0.0},
   {-1.0, 0.0, 0.0},
   {-0.707, 0.0, 0.707},
   {0.0, 0.0, 1.0},
   {0.707, 0.0, 0.707},
   {1.0, 0.0, 0.0},
   {0.707, 0.0, -0.707},
   {0.0, 0.0, -1.0},
   {-0.707, 0.0, -0.707},
   {-1.0, 0.0, 0.0}
};

void Spruce::jehlan() {
   glNewList(list + 1, GL_COMPILE);
     glEnableClientState(GL_VERTEX_ARRAY);
     glEnableClientState(GL_NORMAL_ARRAY);
     glEnableClientState(GL_TEXTURE_COORD_ARRAY);
     glNormalPointer(GL_FLOAT, 0, jehlan_vertex_normal);
     glTexCoordPointer(2, GL_FLOAT, 0, jehlan_vertex_tex);
     glVertexPointer(3, GL_FLOAT, 0, jehlan_vertex_up);
     glDrawArrays(GL_TRIANGLE_FAN, 0, 10);
 
     glDisableClientState(GL_NORMAL_ARRAY);
     glDisableClientState(GL_TEXTURE_COORD_ARRAY);

     glNormal3f(0, -1, 0);
     glVertexPointer(3, GL_FLOAT, 0, jehlan_vertex_down);
     glDrawArrays(GL_TRIANGLE_FAN, 0, 10);
   glEndList();
}

void Spruce::jehlicnan() {
   glNewList(list, GL_COMPILE);
     glPushMatrix();
     glBindTexture(GL_TEXTURE_2D, noha->getTexID());
     glEnable(GL_NORMALIZE);
     glScaled(2.0, 2.5, 2.0);
     glBegin(GL_QUADS);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(0.0, 0.0); glVertex3f(-0.2, 0.0, -0.2);
       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 0.0); glVertex3f(0.2, 0.0, -0.2);
       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 1.0); glVertex3f(0.2, 1.0, -0.2);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(0.0, 1.0); glVertex3f(-0.2, 1.0, -0.2);

       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 0.0); glVertex3f(0.2, 0.0, -0.2);
       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 0.0); glVertex3f(0.2, 0.0, 0.2);
       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 1.0); glVertex3f(0.2, 1.0, 0.2);
       glNormal3f(-0.707, 0.0, 0.707); glTexCoord2f(0.25, 1.0); glVertex3f(0.2, 1.0, -0.2);

       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 0.0); glVertex3f(0.2, 0.0, 0.2);
       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 0.0); glVertex3f(-0.2, 0.0, 0.2);
       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 1.0); glVertex3f(-0.2, 1.0, 0.2);
       glNormal3f(-0.707, 0.0, -0.707); glTexCoord2f(0.5, 1.0); glVertex3f(0.2, 1.0, 0.2);

       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 0.0); glVertex3f(-0.2, 0.0, 0.2);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(1.0, 0.0); glVertex3f(-0.2, 0.0, -0.2);
       glNormal3f(0.707, 0.0, 0.707); glTexCoord2f(1.0, 1.0); glVertex3f(-0.2, 1.0, -0.2);
       glNormal3f(0.707, 0.0, -0.707); glTexCoord2f(0.75, 1.0); glVertex3f(-0.2, 1.0, 0.2);
     glEnd();
     glTranslated(0, 1, 0);
     glScaled(1.5, 0.75, 1.5);
     glBindTexture(GL_TEXTURE_2D, jehlici->getTexID());
     glCallList(list + 1);
     glTranslated(0, 1.5, 0);
     glScaled(0.75, 1.25, 0.75);
     glCallList(list + 1);
     glTranslated(0, 1.5, 0);
     glScaled(0.75, 1.5, 0.75);
     glCallList(list + 1);
     glDisable(GL_NORMALIZE);
     glPopMatrix();
   glEndList();
}

void Spruce::bounds() {
   glBegin(GL_LINE_STRIP);
     glVertex3f(-3, 0, 3);
     glVertex3f(-3, 17, 3);
     glVertex3f(3, 17, 3);
     glVertex3f(3, 0, 3);
   glEnd();
   glBegin(GL_LINE_STRIP);
     glVertex3f(-3, 0, -3);
     glVertex3f(-3, 17, -3);
     glVertex3f(3, 17, -3);
     glVertex3f(3, 0, -3);
   glEnd();
   glBegin(GL_LINES);
     glVertex3f(-3, 17, 3);
     glVertex3f(-3, 17, -3);
     glVertex3f(3, 17, 3);
     glVertex3f(3, 17, -3);
   glEnd();
}

void Spruce::innerDraw() {
   glCallList(list);
}

char *Spruce::save() {
   char name[255];
   sprintf(name, "\nS %d %d", x, y);
   return name;
}

char *Spruce::getName() {
   char *name;
   name = new char[255];
   sprintf(name, "Spruce %d", index);
   return name;
}

