#ifndef STORAGE_H
#define STORAGE_H

#include "object.h"
#include "camera.h"

class Storage {
   private:
      Object *head;
      int selected;
	public:
		Storage(char *filename);
		~Storage();
		void show(void);
		inline bool isSelected(void) {return selected != 0;}
		inline void deselect(void) {selected = 0;}
		char *select(int x, int y, Camera *cam);
		void add(Object *object);
		void erase();
		void moveX(int dx);
		void moveY(int dy);
		void rotate(int angle);
		void save(char *filename);
};

#endif
