#include <GL/gl.h>
#include "surface.h"

Surface::Surface() {
   grass = new Texture("data/grass.tga");
   path = new Texture("data/path.tga");
}

Surface::~Surface() {
   delete grass;
   delete path;
}

void Surface::draw() {
   glBindTexture(GL_TEXTURE_2D, grass->getTexID());
   glBegin(GL_QUADS);
     glNormal3f(0, -1, 0);
     for(int i = -10; i < 10; i++) {
         for(int j = -10; j < 10; j++) {
           glTexCoord2f(0,0); glVertex3f(i*20, -0.05, j*20);
           glTexCoord2f(0,1); glVertex3f((i+1)*20, -0.05, j*20);
           glTexCoord2f(1,1); glVertex3f((i+1)*20, -0.05, (j+1)*20);
           glTexCoord2f(1,0); glVertex3f(i*20, -0.05, (j+1)*20);
         }
     }
   glEnd();
   glDisable(GL_DEPTH_TEST);
   glBindTexture(GL_TEXTURE_2D, path->getTexID());
   glBegin(GL_QUADS);
     glNormal3f(0, -1, 0);
     for(int i = -25; i < 25; i++) {
        glTexCoord2f(0,0); glVertex3f(i*3, 0.0, 4);
        glTexCoord2f(0,1); glVertex3f(i*3, 0.0, 6);
        glTexCoord2f(6,1); glVertex3f((i+1)*3, 0.0, 6);
        glTexCoord2f(6,0); glVertex3f((i+1)*3, 0.0, 4);
     }
   glEnd();
   glEnable(GL_DEPTH_TEST);
}
